From 8a13f13d6a4519258e096afa4ece4bbfa59c4072 Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Wed, 10 May 2023 17:35:56 +0200
Subject: [PATCH] stand/edk2: Reorganize the edk2 contrib hierarchy a bit.

* Move sys/contrib/edk2 to stand/contrib/edk2 where it really belongs.

* Put the *Pkg dir as an additional layer. Work that is currently in
  progress will require headers from other *Pkg's and we don't want to
  jumble them all into one directory.

In-discussion-with: aly
---
 lib/libefivar/Makefile                                        | 2 +-
 stand/boot/efi/boot1/Makefile                                 | 4 ++--
 stand/boot/efi/libefi/Makefile                                | 4 ++--
 stand/boot/efi/loader/arch/x86_64/Makefile.inc                | 4 ++--
 .../contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Base.h | 0
 .../edk2 => stand/contrib/edk2/MdePkg}/Include/Guid/Acpi.h    | 0
 .../contrib/edk2/MdePkg}/Include/Guid/DebugImageInfoTable.h   | 0
 .../contrib/edk2/MdePkg}/Include/Guid/DxeServices.h           | 0
 .../contrib/edk2/MdePkg}/Include/Guid/HiiFormMapMethodGuid.h  | 0
 .../edk2 => stand/contrib/edk2/MdePkg}/Include/Guid/HobList.h | 0
 .../edk2 => stand/contrib/edk2/MdePkg}/Include/Guid/Mps.h     | 0
 .../edk2 => stand/contrib/edk2/MdePkg}/Include/Guid/PcAnsi.h  | 0
 .../edk2 => stand/contrib/edk2/MdePkg}/Include/Guid/SmBios.h  | 0
 .../contrib/edk2/MdePkg}/Include/Guid/WinCertificate.h        | 0
 .../contrib/edk2/MdePkg}/Include/IndustryStandard/Acpi10.h    | 0
 .../contrib/edk2/MdePkg}/Include/IndustryStandard/Acpi20.h    | 0
 .../contrib/edk2/MdePkg}/Include/IndustryStandard/Acpi30.h    | 0
 .../contrib/edk2/MdePkg}/Include/IndustryStandard/Acpi40.h    | 0
 .../contrib/edk2/MdePkg}/Include/IndustryStandard/Acpi50.h    | 0
 .../contrib/edk2/MdePkg}/Include/IndustryStandard/Acpi51.h    | 0
 .../contrib/edk2/MdePkg}/Include/IndustryStandard/Acpi60.h    | 0
 .../contrib/edk2/MdePkg}/Include/IndustryStandard/AcpiAml.h   | 0
 .../contrib/edk2/MdePkg}/Include/IndustryStandard/Bluetooth.h | 0
 .../contrib/edk2/MdePkg}/Include/Library/BaseLib.h            | 0
 .../contrib/edk2/MdePkg}/Include/Library/BaseMemoryLib.h      | 0
 .../contrib/edk2/MdePkg}/Include/Library/DebugLib.h           | 0
 .../contrib/edk2/MdePkg}/Include/Library/DevicePathLib.h      | 0
 .../edk2/MdePkg}/Include/Library/MemoryAllocationLib.h        | 0
 .../contrib/edk2/MdePkg}/Include/Library/PcdLib.h             | 0
 .../contrib/edk2/MdePkg}/Include/Library/PrintLib.h           | 0
 .../edk2/MdePkg}/Include/Library/UefiBootServicesTableLib.h   | 0
 .../contrib/edk2/MdePkg}/Include/Protocol/BlockIo.h           | 0
 .../contrib/edk2/MdePkg}/Include/Protocol/DebugPort.h         | 0
 .../contrib/edk2/MdePkg}/Include/Protocol/DevicePath.h        | 0
 .../edk2/MdePkg}/Include/Protocol/DevicePathFromText.h        | 0
 .../contrib/edk2/MdePkg}/Include/Protocol/DevicePathToText.h  | 0
 .../edk2/MdePkg}/Include/Protocol/DevicePathUtilities.h       | 0
 .../contrib/edk2/MdePkg}/Include/Protocol/GraphicsOutput.h    | 0
 .../contrib/edk2/MdePkg}/Include/Protocol/LoadedImage.h       | 0
 .../MdePkg}/Include/Protocol/NetworkInterfaceIdentifier.h     | 0
 .../contrib/edk2/MdePkg}/Include/Protocol/PciIo.h             | 0
 .../contrib/edk2/MdePkg}/Include/Protocol/SerialIo.h          | 0
 .../contrib/edk2/MdePkg}/Include/Protocol/SimpleNetwork.h     | 0
 .../contrib/edk2/MdePkg}/Include/Protocol/SimpleTextIn.h      | 0
 .../contrib/edk2/MdePkg}/Include/Protocol/SimpleTextInEx.h    | 0
 .../contrib/edk2/MdePkg}/Include/Protocol/SimpleTextOut.h     | 0
 .../contrib/edk2/MdePkg}/Include/Protocol/UgaDraw.h           | 0
 .../contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Uefi.h | 0
 .../contrib/edk2/MdePkg}/Include/Uefi/UefiBaseType.h          | 0
 .../edk2 => stand/contrib/edk2/MdePkg}/Include/Uefi/UefiGpt.h | 0
 .../MdePkg}/Include/Uefi/UefiInternalFormRepresentation.h     | 0
 .../contrib/edk2/MdePkg}/Include/Uefi/UefiMultiPhase.h        | 0
 .../edk2 => stand/contrib/edk2/MdePkg}/Include/Uefi/UefiPxe.h | 0
 .../contrib/edk2/MdePkg}/Include/Uefi/UefiSpec.h              | 0
 .../contrib/edk2/MdePkg}/Include/X64/ProcessorBind.h          | 0
 55 files changed, 7 insertions(+), 7 deletions(-)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Base.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Guid/Acpi.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Guid/DebugImageInfoTable.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Guid/DxeServices.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Guid/HiiFormMapMethodGuid.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Guid/HobList.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Guid/Mps.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Guid/PcAnsi.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Guid/SmBios.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Guid/WinCertificate.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/IndustryStandard/Acpi10.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/IndustryStandard/Acpi20.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/IndustryStandard/Acpi30.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/IndustryStandard/Acpi40.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/IndustryStandard/Acpi50.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/IndustryStandard/Acpi51.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/IndustryStandard/Acpi60.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/IndustryStandard/AcpiAml.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/IndustryStandard/Bluetooth.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Library/BaseLib.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Library/BaseMemoryLib.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Library/DebugLib.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Library/DevicePathLib.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Library/MemoryAllocationLib.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Library/PcdLib.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Library/PrintLib.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Library/UefiBootServicesTableLib.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Protocol/BlockIo.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Protocol/DebugPort.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Protocol/DevicePath.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Protocol/DevicePathFromText.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Protocol/DevicePathToText.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Protocol/DevicePathUtilities.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Protocol/GraphicsOutput.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Protocol/LoadedImage.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Protocol/NetworkInterfaceIdentifier.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Protocol/PciIo.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Protocol/SerialIo.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Protocol/SimpleNetwork.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Protocol/SimpleTextIn.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Protocol/SimpleTextInEx.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Protocol/SimpleTextOut.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Protocol/UgaDraw.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Uefi.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Uefi/UefiBaseType.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Uefi/UefiGpt.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Uefi/UefiInternalFormRepresentation.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Uefi/UefiMultiPhase.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Uefi/UefiPxe.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/Uefi/UefiSpec.h (100%)
 rename {sys/contrib/edk2 => stand/contrib/edk2/MdePkg}/Include/X64/ProcessorBind.h (100%)

diff --git a/lib/libefivar/Makefile b/lib/libefivar/Makefile
index 727fd1872fb..a320d1fac4b 100644
--- a/lib/libefivar/Makefile
+++ b/lib/libefivar/Makefile
@@ -25,7 +25,7 @@
 # $FreeBSD: head/lib/libefivar/Makefile 326458 2017-12-02 07:29:19Z imp $
 
 EFIBOOT=${.CURDIR}/../../stand/boot/efi
-EDK2INC=${.CURDIR}/../../sys/contrib/edk2/Include
+EDK2INC=${.CURDIR}/../../stand/contrib/edk2/MdePkg/Include
 
 .PATH:	${EFIBOOT}/libefi
 
diff --git a/stand/boot/efi/boot1/Makefile b/stand/boot/efi/boot1/Makefile
index e37203264d8..a6091349d8f 100644
--- a/stand/boot/efi/boot1/Makefile
+++ b/stand/boot/efi/boot1/Makefile
@@ -16,12 +16,12 @@ CFLAGS+=	-I.
 CFLAGS+=	-I${.CURDIR}/../include
 CFLAGS+=	-I${.CURDIR}/../../../lib
 CFLAGS+=	-I${.CURDIR}/../../../../sys/contrib/dev/acpica/source/include
-CFLAGS+=	-I${.CURDIR}/../../../../sys/contrib/edk2/Include
+CFLAGS+=	-I${.CURDIR}/../../../contrib/edk2/MdePkg/Include
 CFLAGS+=	-I${.CURDIR}/../../../../sys
 CFLAGS+=	-DEFI_UFS_BOOT
 
 .if ${MACHINE_ARCH} == "x86_64"
-CFLAGS+=	-I${.CURDIR}/../../../../sys/contrib/edk2/Include/X64
+CFLAGS+=	-I${.CURDIR}/../../../contrib/edk2/MdePkg/Include/X64
 .endif
 
 # Disable stack protector
diff --git a/stand/boot/efi/libefi/Makefile b/stand/boot/efi/libefi/Makefile
index 06d2e603758..26b9e36a9b2 100644
--- a/stand/boot/efi/libefi/Makefile
+++ b/stand/boot/efi/libefi/Makefile
@@ -9,10 +9,10 @@ SRCS=	delay.c efi_console.c efinet.c efipart.c errno.c handles.c \
 
 .if ${MACHINE_ARCH} == "x86_64"
 CFLAGS+= -fPIC -mno-red-zone
-CFLAGS+= -I${.CURDIR}/../../../../sys/contrib/edk2/Include/X64
+CFLAGS+= -I${.CURDIR}/../../../contrib/edk2/MdePkg/Include/X64
 .endif
 CFLAGS+= -I${.CURDIR}/../include
-CFLAGS+= -I${.CURDIR}/../../../../sys/contrib/edk2/Include
+CFLAGS+= -I${.CURDIR}/../../../contrib/edk2/MdePkg/Include
 CFLAGS+= -I${.CURDIR}/../../../lib
 
 # Pick up the bootstrap header for some interface items
diff --git a/stand/boot/efi/loader/arch/x86_64/Makefile.inc b/stand/boot/efi/loader/arch/x86_64/Makefile.inc
index 667cdf88b5a..4bdad5baeea 100644
--- a/stand/boot/efi/loader/arch/x86_64/Makefile.inc
+++ b/stand/boot/efi/loader/arch/x86_64/Makefile.inc
@@ -13,8 +13,8 @@ SRCS+=	nullconsole.c \
 CFLAGS+=	-fno-stack-protector
 
 CFLAGS+=	-fPIC
-CFLAGS+=	-I${.CURDIR}/../../../../sys/contrib/edk2/Include
-CFLAGS+=	-I${.CURDIR}/../../../../sys/contrib/edk2/Include/X64
+CFLAGS+=	-I${.CURDIR}/../../../contrib/edk2/MdePkg/Include
+CFLAGS+=	-I${.CURDIR}/../../../contrib/edk2/MdePkg/Include/X64
 LDFLAGS+=	-Wl,-znocombreloc
 
 FLAGS_GROUPS=	inttypes
diff --git a/sys/contrib/edk2/Include/Base.h b/stand/contrib/edk2/MdePkg/Include/Base.h
similarity index 100%
rename from sys/contrib/edk2/Include/Base.h
rename to stand/contrib/edk2/MdePkg/Include/Base.h
diff --git a/sys/contrib/edk2/Include/Guid/Acpi.h b/stand/contrib/edk2/MdePkg/Include/Guid/Acpi.h
similarity index 100%
rename from sys/contrib/edk2/Include/Guid/Acpi.h
rename to stand/contrib/edk2/MdePkg/Include/Guid/Acpi.h
diff --git a/sys/contrib/edk2/Include/Guid/DebugImageInfoTable.h b/stand/contrib/edk2/MdePkg/Include/Guid/DebugImageInfoTable.h
similarity index 100%
rename from sys/contrib/edk2/Include/Guid/DebugImageInfoTable.h
rename to stand/contrib/edk2/MdePkg/Include/Guid/DebugImageInfoTable.h
diff --git a/sys/contrib/edk2/Include/Guid/DxeServices.h b/stand/contrib/edk2/MdePkg/Include/Guid/DxeServices.h
similarity index 100%
rename from sys/contrib/edk2/Include/Guid/DxeServices.h
rename to stand/contrib/edk2/MdePkg/Include/Guid/DxeServices.h
diff --git a/sys/contrib/edk2/Include/Guid/HiiFormMapMethodGuid.h b/stand/contrib/edk2/MdePkg/Include/Guid/HiiFormMapMethodGuid.h
similarity index 100%
rename from sys/contrib/edk2/Include/Guid/HiiFormMapMethodGuid.h
rename to stand/contrib/edk2/MdePkg/Include/Guid/HiiFormMapMethodGuid.h
diff --git a/sys/contrib/edk2/Include/Guid/HobList.h b/stand/contrib/edk2/MdePkg/Include/Guid/HobList.h
similarity index 100%
rename from sys/contrib/edk2/Include/Guid/HobList.h
rename to stand/contrib/edk2/MdePkg/Include/Guid/HobList.h
diff --git a/sys/contrib/edk2/Include/Guid/Mps.h b/stand/contrib/edk2/MdePkg/Include/Guid/Mps.h
similarity index 100%
rename from sys/contrib/edk2/Include/Guid/Mps.h
rename to stand/contrib/edk2/MdePkg/Include/Guid/Mps.h
diff --git a/sys/contrib/edk2/Include/Guid/PcAnsi.h b/stand/contrib/edk2/MdePkg/Include/Guid/PcAnsi.h
similarity index 100%
rename from sys/contrib/edk2/Include/Guid/PcAnsi.h
rename to stand/contrib/edk2/MdePkg/Include/Guid/PcAnsi.h
diff --git a/sys/contrib/edk2/Include/Guid/SmBios.h b/stand/contrib/edk2/MdePkg/Include/Guid/SmBios.h
similarity index 100%
rename from sys/contrib/edk2/Include/Guid/SmBios.h
rename to stand/contrib/edk2/MdePkg/Include/Guid/SmBios.h
diff --git a/sys/contrib/edk2/Include/Guid/WinCertificate.h b/stand/contrib/edk2/MdePkg/Include/Guid/WinCertificate.h
similarity index 100%
rename from sys/contrib/edk2/Include/Guid/WinCertificate.h
rename to stand/contrib/edk2/MdePkg/Include/Guid/WinCertificate.h
diff --git a/sys/contrib/edk2/Include/IndustryStandard/Acpi10.h b/stand/contrib/edk2/MdePkg/Include/IndustryStandard/Acpi10.h
similarity index 100%
rename from sys/contrib/edk2/Include/IndustryStandard/Acpi10.h
rename to stand/contrib/edk2/MdePkg/Include/IndustryStandard/Acpi10.h
diff --git a/sys/contrib/edk2/Include/IndustryStandard/Acpi20.h b/stand/contrib/edk2/MdePkg/Include/IndustryStandard/Acpi20.h
similarity index 100%
rename from sys/contrib/edk2/Include/IndustryStandard/Acpi20.h
rename to stand/contrib/edk2/MdePkg/Include/IndustryStandard/Acpi20.h
diff --git a/sys/contrib/edk2/Include/IndustryStandard/Acpi30.h b/stand/contrib/edk2/MdePkg/Include/IndustryStandard/Acpi30.h
similarity index 100%
rename from sys/contrib/edk2/Include/IndustryStandard/Acpi30.h
rename to stand/contrib/edk2/MdePkg/Include/IndustryStandard/Acpi30.h
diff --git a/sys/contrib/edk2/Include/IndustryStandard/Acpi40.h b/stand/contrib/edk2/MdePkg/Include/IndustryStandard/Acpi40.h
similarity index 100%
rename from sys/contrib/edk2/Include/IndustryStandard/Acpi40.h
rename to stand/contrib/edk2/MdePkg/Include/IndustryStandard/Acpi40.h
diff --git a/sys/contrib/edk2/Include/IndustryStandard/Acpi50.h b/stand/contrib/edk2/MdePkg/Include/IndustryStandard/Acpi50.h
similarity index 100%
rename from sys/contrib/edk2/Include/IndustryStandard/Acpi50.h
rename to stand/contrib/edk2/MdePkg/Include/IndustryStandard/Acpi50.h
diff --git a/sys/contrib/edk2/Include/IndustryStandard/Acpi51.h b/stand/contrib/edk2/MdePkg/Include/IndustryStandard/Acpi51.h
similarity index 100%
rename from sys/contrib/edk2/Include/IndustryStandard/Acpi51.h
rename to stand/contrib/edk2/MdePkg/Include/IndustryStandard/Acpi51.h
diff --git a/sys/contrib/edk2/Include/IndustryStandard/Acpi60.h b/stand/contrib/edk2/MdePkg/Include/IndustryStandard/Acpi60.h
similarity index 100%
rename from sys/contrib/edk2/Include/IndustryStandard/Acpi60.h
rename to stand/contrib/edk2/MdePkg/Include/IndustryStandard/Acpi60.h
diff --git a/sys/contrib/edk2/Include/IndustryStandard/AcpiAml.h b/stand/contrib/edk2/MdePkg/Include/IndustryStandard/AcpiAml.h
similarity index 100%
rename from sys/contrib/edk2/Include/IndustryStandard/AcpiAml.h
rename to stand/contrib/edk2/MdePkg/Include/IndustryStandard/AcpiAml.h
diff --git a/sys/contrib/edk2/Include/IndustryStandard/Bluetooth.h b/stand/contrib/edk2/MdePkg/Include/IndustryStandard/Bluetooth.h
similarity index 100%
rename from sys/contrib/edk2/Include/IndustryStandard/Bluetooth.h
rename to stand/contrib/edk2/MdePkg/Include/IndustryStandard/Bluetooth.h
diff --git a/sys/contrib/edk2/Include/Library/BaseLib.h b/stand/contrib/edk2/MdePkg/Include/Library/BaseLib.h
similarity index 100%
rename from sys/contrib/edk2/Include/Library/BaseLib.h
rename to stand/contrib/edk2/MdePkg/Include/Library/BaseLib.h
diff --git a/sys/contrib/edk2/Include/Library/BaseMemoryLib.h b/stand/contrib/edk2/MdePkg/Include/Library/BaseMemoryLib.h
similarity index 100%
rename from sys/contrib/edk2/Include/Library/BaseMemoryLib.h
rename to stand/contrib/edk2/MdePkg/Include/Library/BaseMemoryLib.h
diff --git a/sys/contrib/edk2/Include/Library/DebugLib.h b/stand/contrib/edk2/MdePkg/Include/Library/DebugLib.h
similarity index 100%
rename from sys/contrib/edk2/Include/Library/DebugLib.h
rename to stand/contrib/edk2/MdePkg/Include/Library/DebugLib.h
diff --git a/sys/contrib/edk2/Include/Library/DevicePathLib.h b/stand/contrib/edk2/MdePkg/Include/Library/DevicePathLib.h
similarity index 100%
rename from sys/contrib/edk2/Include/Library/DevicePathLib.h
rename to stand/contrib/edk2/MdePkg/Include/Library/DevicePathLib.h
diff --git a/sys/contrib/edk2/Include/Library/MemoryAllocationLib.h b/stand/contrib/edk2/MdePkg/Include/Library/MemoryAllocationLib.h
similarity index 100%
rename from sys/contrib/edk2/Include/Library/MemoryAllocationLib.h
rename to stand/contrib/edk2/MdePkg/Include/Library/MemoryAllocationLib.h
diff --git a/sys/contrib/edk2/Include/Library/PcdLib.h b/stand/contrib/edk2/MdePkg/Include/Library/PcdLib.h
similarity index 100%
rename from sys/contrib/edk2/Include/Library/PcdLib.h
rename to stand/contrib/edk2/MdePkg/Include/Library/PcdLib.h
diff --git a/sys/contrib/edk2/Include/Library/PrintLib.h b/stand/contrib/edk2/MdePkg/Include/Library/PrintLib.h
similarity index 100%
rename from sys/contrib/edk2/Include/Library/PrintLib.h
rename to stand/contrib/edk2/MdePkg/Include/Library/PrintLib.h
diff --git a/sys/contrib/edk2/Include/Library/UefiBootServicesTableLib.h b/stand/contrib/edk2/MdePkg/Include/Library/UefiBootServicesTableLib.h
similarity index 100%
rename from sys/contrib/edk2/Include/Library/UefiBootServicesTableLib.h
rename to stand/contrib/edk2/MdePkg/Include/Library/UefiBootServicesTableLib.h
diff --git a/sys/contrib/edk2/Include/Protocol/BlockIo.h b/stand/contrib/edk2/MdePkg/Include/Protocol/BlockIo.h
similarity index 100%
rename from sys/contrib/edk2/Include/Protocol/BlockIo.h
rename to stand/contrib/edk2/MdePkg/Include/Protocol/BlockIo.h
diff --git a/sys/contrib/edk2/Include/Protocol/DebugPort.h b/stand/contrib/edk2/MdePkg/Include/Protocol/DebugPort.h
similarity index 100%
rename from sys/contrib/edk2/Include/Protocol/DebugPort.h
rename to stand/contrib/edk2/MdePkg/Include/Protocol/DebugPort.h
diff --git a/sys/contrib/edk2/Include/Protocol/DevicePath.h b/stand/contrib/edk2/MdePkg/Include/Protocol/DevicePath.h
similarity index 100%
rename from sys/contrib/edk2/Include/Protocol/DevicePath.h
rename to stand/contrib/edk2/MdePkg/Include/Protocol/DevicePath.h
diff --git a/sys/contrib/edk2/Include/Protocol/DevicePathFromText.h b/stand/contrib/edk2/MdePkg/Include/Protocol/DevicePathFromText.h
similarity index 100%
rename from sys/contrib/edk2/Include/Protocol/DevicePathFromText.h
rename to stand/contrib/edk2/MdePkg/Include/Protocol/DevicePathFromText.h
diff --git a/sys/contrib/edk2/Include/Protocol/DevicePathToText.h b/stand/contrib/edk2/MdePkg/Include/Protocol/DevicePathToText.h
similarity index 100%
rename from sys/contrib/edk2/Include/Protocol/DevicePathToText.h
rename to stand/contrib/edk2/MdePkg/Include/Protocol/DevicePathToText.h
diff --git a/sys/contrib/edk2/Include/Protocol/DevicePathUtilities.h b/stand/contrib/edk2/MdePkg/Include/Protocol/DevicePathUtilities.h
similarity index 100%
rename from sys/contrib/edk2/Include/Protocol/DevicePathUtilities.h
rename to stand/contrib/edk2/MdePkg/Include/Protocol/DevicePathUtilities.h
diff --git a/sys/contrib/edk2/Include/Protocol/GraphicsOutput.h b/stand/contrib/edk2/MdePkg/Include/Protocol/GraphicsOutput.h
similarity index 100%
rename from sys/contrib/edk2/Include/Protocol/GraphicsOutput.h
rename to stand/contrib/edk2/MdePkg/Include/Protocol/GraphicsOutput.h
diff --git a/sys/contrib/edk2/Include/Protocol/LoadedImage.h b/stand/contrib/edk2/MdePkg/Include/Protocol/LoadedImage.h
similarity index 100%
rename from sys/contrib/edk2/Include/Protocol/LoadedImage.h
rename to stand/contrib/edk2/MdePkg/Include/Protocol/LoadedImage.h
diff --git a/sys/contrib/edk2/Include/Protocol/NetworkInterfaceIdentifier.h b/stand/contrib/edk2/MdePkg/Include/Protocol/NetworkInterfaceIdentifier.h
similarity index 100%
rename from sys/contrib/edk2/Include/Protocol/NetworkInterfaceIdentifier.h
rename to stand/contrib/edk2/MdePkg/Include/Protocol/NetworkInterfaceIdentifier.h
diff --git a/sys/contrib/edk2/Include/Protocol/PciIo.h b/stand/contrib/edk2/MdePkg/Include/Protocol/PciIo.h
similarity index 100%
rename from sys/contrib/edk2/Include/Protocol/PciIo.h
rename to stand/contrib/edk2/MdePkg/Include/Protocol/PciIo.h
diff --git a/sys/contrib/edk2/Include/Protocol/SerialIo.h b/stand/contrib/edk2/MdePkg/Include/Protocol/SerialIo.h
similarity index 100%
rename from sys/contrib/edk2/Include/Protocol/SerialIo.h
rename to stand/contrib/edk2/MdePkg/Include/Protocol/SerialIo.h
diff --git a/sys/contrib/edk2/Include/Protocol/SimpleNetwork.h b/stand/contrib/edk2/MdePkg/Include/Protocol/SimpleNetwork.h
similarity index 100%
rename from sys/contrib/edk2/Include/Protocol/SimpleNetwork.h
rename to stand/contrib/edk2/MdePkg/Include/Protocol/SimpleNetwork.h
diff --git a/sys/contrib/edk2/Include/Protocol/SimpleTextIn.h b/stand/contrib/edk2/MdePkg/Include/Protocol/SimpleTextIn.h
similarity index 100%
rename from sys/contrib/edk2/Include/Protocol/SimpleTextIn.h
rename to stand/contrib/edk2/MdePkg/Include/Protocol/SimpleTextIn.h
diff --git a/sys/contrib/edk2/Include/Protocol/SimpleTextInEx.h b/stand/contrib/edk2/MdePkg/Include/Protocol/SimpleTextInEx.h
similarity index 100%
rename from sys/contrib/edk2/Include/Protocol/SimpleTextInEx.h
rename to stand/contrib/edk2/MdePkg/Include/Protocol/SimpleTextInEx.h
diff --git a/sys/contrib/edk2/Include/Protocol/SimpleTextOut.h b/stand/contrib/edk2/MdePkg/Include/Protocol/SimpleTextOut.h
similarity index 100%
rename from sys/contrib/edk2/Include/Protocol/SimpleTextOut.h
rename to stand/contrib/edk2/MdePkg/Include/Protocol/SimpleTextOut.h
diff --git a/sys/contrib/edk2/Include/Protocol/UgaDraw.h b/stand/contrib/edk2/MdePkg/Include/Protocol/UgaDraw.h
similarity index 100%
rename from sys/contrib/edk2/Include/Protocol/UgaDraw.h
rename to stand/contrib/edk2/MdePkg/Include/Protocol/UgaDraw.h
diff --git a/sys/contrib/edk2/Include/Uefi.h b/stand/contrib/edk2/MdePkg/Include/Uefi.h
similarity index 100%
rename from sys/contrib/edk2/Include/Uefi.h
rename to stand/contrib/edk2/MdePkg/Include/Uefi.h
diff --git a/sys/contrib/edk2/Include/Uefi/UefiBaseType.h b/stand/contrib/edk2/MdePkg/Include/Uefi/UefiBaseType.h
similarity index 100%
rename from sys/contrib/edk2/Include/Uefi/UefiBaseType.h
rename to stand/contrib/edk2/MdePkg/Include/Uefi/UefiBaseType.h
diff --git a/sys/contrib/edk2/Include/Uefi/UefiGpt.h b/stand/contrib/edk2/MdePkg/Include/Uefi/UefiGpt.h
similarity index 100%
rename from sys/contrib/edk2/Include/Uefi/UefiGpt.h
rename to stand/contrib/edk2/MdePkg/Include/Uefi/UefiGpt.h
diff --git a/sys/contrib/edk2/Include/Uefi/UefiInternalFormRepresentation.h b/stand/contrib/edk2/MdePkg/Include/Uefi/UefiInternalFormRepresentation.h
similarity index 100%
rename from sys/contrib/edk2/Include/Uefi/UefiInternalFormRepresentation.h
rename to stand/contrib/edk2/MdePkg/Include/Uefi/UefiInternalFormRepresentation.h
diff --git a/sys/contrib/edk2/Include/Uefi/UefiMultiPhase.h b/stand/contrib/edk2/MdePkg/Include/Uefi/UefiMultiPhase.h
similarity index 100%
rename from sys/contrib/edk2/Include/Uefi/UefiMultiPhase.h
rename to stand/contrib/edk2/MdePkg/Include/Uefi/UefiMultiPhase.h
diff --git a/sys/contrib/edk2/Include/Uefi/UefiPxe.h b/stand/contrib/edk2/MdePkg/Include/Uefi/UefiPxe.h
similarity index 100%
rename from sys/contrib/edk2/Include/Uefi/UefiPxe.h
rename to stand/contrib/edk2/MdePkg/Include/Uefi/UefiPxe.h
diff --git a/sys/contrib/edk2/Include/Uefi/UefiSpec.h b/stand/contrib/edk2/MdePkg/Include/Uefi/UefiSpec.h
similarity index 100%
rename from sys/contrib/edk2/Include/Uefi/UefiSpec.h
rename to stand/contrib/edk2/MdePkg/Include/Uefi/UefiSpec.h
diff --git a/sys/contrib/edk2/Include/X64/ProcessorBind.h b/stand/contrib/edk2/MdePkg/Include/X64/ProcessorBind.h
similarity index 100%
rename from sys/contrib/edk2/Include/X64/ProcessorBind.h
rename to stand/contrib/edk2/MdePkg/Include/X64/ProcessorBind.h
-- 
2.39.2